<?php
/**
 * ARAMBA. Version 1.0.0
 * @package Joomla.JoomShopping
 * @author Anton Okhrimenko
 * @website http://www.aramba.ru
 * @email mail@aramba.ru
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined("_JEXEC") or die("Restricted access");
jimport('joomla.application.component.controller');

class plgJShoppingCheckoutARAMBA_RU extends JPlugin
{
    public function onEndCheckoutStep5(&$order){
	  // Get plugin params
		file_put_contents("aramba_log.txt", "onEndCheckoutStep5...\r\n", FILE_APPEND);
        $tableAddon = JTable::getInstance("Addon", "JShop");
		$tableAddon->loadAlias("ARAMBA_RU");
		$params = $tableAddon->getParams();
        
        if(!$params['aramba_addon_enable']) return;

        JFactory::getLanguage()->load('ARAMBA_RU', JPATH_SITE.'/components/com_jshopping/addons/ARAMBA_RU');
        
        $ch = curl_init("https://api.aramba.ru/singleSms");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array(  
				'Accept: application/json',  
				'Content-Type: application/json',  
				'Authorization: ApiKey ' . $params['aramba_api_key']
			)
		);
		file_put_contents("aramba_log.txt", "api_key: " . $params['aramba_api_key'] . "\r\n", FILE_APPEND);
		$post_data = json_encode(
			array(	
					'senderId' => $params['aramba_senders'],
					'sendDateTime' => '',
					'useRecepientTimeZone' => 'false',
					'phoneNumber' => $params['aramba_admin_phone'],
					'text' => $this->__getSendingText($order, $params['aramba_sms_text_to_admin'])
			)
		);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
		file_put_contents("aramba_log.txt", $post_data . "\r\n", FILE_APPEND);
        $response = curl_exec($ch);
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		
		file_put_contents("aramba_log.txt", "response: " . $response . "\r\n", FILE_APPEND);
		file_put_contents("aramba_log.txt", "http_code: " . $http_code . "\r\n\r\n", FILE_APPEND);
		
		
        curl_close($ch);
        
        if($params['aramba_send_user_new_order_status']){
        	$phone_field = $params['aramba_send_user_new_order_status_phone_field'];
        	$remove = array("+", "(", ")", " ", "-");
        	$user_phone = str_replace($remove, "", $order->$phone_field);
        	if($user_phone){
        		
        		$ch = curl_init("https://api.aramba.ru/singleSms");;
        		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_POST, true);
        		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
				curl_setopt($ch, CURLOPT_HTTPHEADER, array(  
						'Accept: application/json',  
						'Content-Type: application/json',  
						'Authorization: ApiKey ' . $params['aramba_api_key']
					)
				);
				
				file_put_contents("aramba_log.txt", "api_key: " . $params['aramba_api_key'] . "\r\n", FILE_APPEND);
				$post_data = json_encode(
					array(
						'senderId' => $params['aramba_senders'],
						'sendDateTime' => '',
						'useRecepientTimeZone' => 'false',
						'phoneNumber' => $user_phone,
						'text' => $this->__getSendingText($order, $params['aramba_send_user_new_order_text'])
					)
				);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
				file_put_contents("aramba_log.txt", $post_data . "\r\n", FILE_APPEND);
        		$response = curl_exec($ch);
				$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				
				file_put_contents("aramba_log.txt", "response: " . $response . "\r\n", FILE_APPEND);
				file_put_contents("aramba_log.txt", "http_code: " . $http_code . "\r\n\r\n", FILE_APPEND);
				
        		curl_close($ch);
        		if ($http_code != 200) {
        			JFactory::getApplication()->enqueueMessage(JText::_('ARAMBA_RU_FRONT_ERROR_SEND_SMS'),'error');
        		} 
        		
        	}
        }
    }
    
    /**
     * Creates the final version of the message
     * 
     * @param $order  Object with order data
     * @param $params Plugin parameters
     * 
     * @return string  Message text
     */
    protected function __getSendingText($order, $text){
        $s = array('{ARAMBA_RU_orderid}','{ARAMBA_RU_fname}','{ARAMBA_RU_lname}','{ARAMBA_RU_client_type}','{ARAMBA_RU_firma}','{ARAMBA_RU_code_firma}','{ARAMBA_RU_code_nds}','{ARAMBA_RU_email}',
            '{ARAMBA_RU_birthday}','{ARAMBA_RU_home}','{ARAMBA_RU_apartment}','{ARAMBA_RU_street}','{ARAMBA_RU_postcode}','{ARAMBA_RU_city}','{ARAMBA_RU_state}','{ARAMBA_RU_country}',
            '{ARAMBA_RU_phone}','{ARAMBA_RU_mobil_phone}','{ARAMBA_RU_fax}','{ARAMBA_RU_cost}','{ARAMBA_RU_d_fname}','{ARAMBA_RU_d_lname}','{ARAMBA_RU_d_firma}','{ARAMBA_RU_d_email}',
            '{ARAMBA_RU_d_birthday}','{ARAMBA_RU_d_home}','{ARAMBA_RU_d_apartment}','{ARAMBA_RU_d_street}','{ARAMBA_RU_d_postcode}','{ARAMBA_RU_d_city}','{ARAMBA_RU_d_state}',
            '{ARAMBA_RU_d_country}','{ARAMBA_RU_d_phone}','{ARAMBA_RU_d_mobil_phone}','{ARAMBA_RU_d_fax}');
        // Replace country code
        if(strstr($text, '{ARAMBA_RU_country}')){
	        $row = JTable::getInstance('country', 'jshop');
	        $row->load($order->country);
	        $lang_tag = 'name_'.JFactory::getLanguage()->getTag();
        	$country = $row->$lang_tag;
        }else{
        	$country = $order->country;
        }
		
		// Format cost
		if(strstr($text, '{ARAMBA_RU_cost}')){
			$order_total = formatprice($order->order_total);
		}
        
        $r = array($order->order_number,$order->f_name,$order->l_name,$order->client_type,$order->firma_name,$order->firma_code,$order->tax_number,$order->email,
            $order->birthday,$order->home,$order->apartment,$order->street,$order->zip,$order->city,$order->state,$country,
            $order->phone,$order->mobil_phone,$order->fax,$order_total,$order->d_f_name,$order->d_l_name,$order->d_firma_name,$order->d_email,
            $order->d_birthday,$order->d_home,$order->d_apartment,$order->d_street,$order->d_zip,$order->d_city,$order->d_state,
            $order->d_country,$order->d_phone,$order->d_mobil_phone,$order->d_fax);
        return str_replace($s, $r, $text);
    }
}